module ReimbursementType
  class OriginalPaymentNoItems < Spree::ReimbursementType
    extend Spree::ReimbursementType::ReimbursementHelpers

    class << self
      def reimburse(reimbursement, _return_items, simulate)
        unpaid_amount = reimbursement.total.round(2, :down)
        payments = reimbursement.order.payments.completed

        refund_list, _unpaid_amount = create_refunds(reimbursement, payments, unpaid_amount, simulate)
        reimbursement.update(total: refund_list.sum(&:amount))
        refund_list
      end
    end
  end

end
